#ifndef TOOLBAR_H
#define TOOLBAR_H
#define FITTHEMEWINDOW "org.ukui.style"
#define UKUI_FONT_SIZE "systemFontSize"
#include <QWidget>
#include <QFrame>
#include <QDialog>
#include <QPushButton>
#include <QHBoxLayout>
#include <QLabel>
#include <QDebug>
#include <QMouseEvent>
#include <QtMath>
#include <QPainter>
#include <QGSettings>
#include <QFont>
#include <QGraphicsDropShadowEffect>
#include "controller/interaction.h"
#include <peony-qt/file-operation-utils.h>

class ToolBar : public QWidget
{
    Q_OBJECT
public:
    explicit ToolBar(QWidget *parent = nullptr);
    void updateFileInfo(QFileInfo fileInfo);
    void changePerRate(QString num, QString path);
    void reduceImage();//缩小图片
    void enlargeImage();//放大图片
    void delImage();//删除
    void changeStyle();
    void setButtonState(bool isOpenSuccess, bool isCanOperate);//设置工具栏按钮是否可点击--图片是否打开成功
    QFrame *g_tooleWid;//布局
    void getImageType(bool canCut);

private:

    QHBoxLayout *m_toolLayout;
    QGSettings *m_pGsettingThemeData = nullptr;
    QPushButton *m_reduce;//缩小
    QLabel *m_percentage;//百分比
    QPushButton *m_enlarge;//放大
    QPushButton *m_originalSize;//原始尺寸
    QPushButton *m_adaptiveWidget;//适应图片
    QPushButton *m_rotate;//旋转
    QPushButton *m_flipH;//水平翻转
    QPushButton *m_flipV;//垂直翻转
    QPushButton *m_cutImage;//裁剪
    QLabel *m_line1;
    QPushButton *m_filter;//滤镜
    QPushButton *m_labelbar;//标注栏
    QLabel *m_line2;
    QPushButton *m_sidebar;//侧边栏
    QPushButton *m_information;//详细信息
    QPushButton *m_delImage;//删除图片

    QColor m_color = QColor(190 ,190, 190);
    QBrush m_brush = QBrush(Qt::white);
    QWidget *m_zoomWid;//缩放按钮和比例窗口
    QFont m_ft;//固定字号
    QGSettings *m_fontSize = nullptr;
    QString nowThemeStyle;
    QString m_imagePath;
    bool m_isOpenSuccess = false;//默认图片不进行操作，不是成功打开的状态
    bool m_isCanOperate = false;//默认无权限，不能删除，不能操作
    void originalSize();//原始尺寸
    void adaptiveWidget();//适应窗口
    void rotate();//旋转
    void flipH();//水平翻转
    void flipV();//垂直翻转
    void cutImage();//裁剪
    void filter();//滤镜
    void labelbar();//标注
    void sidebar();//侧边栏--相册
    void information();//信息栏
    //字体变化
    void lable2SetFontSizeSlot(int size);
    void initFontSize();

    void initControlQss();//初始化布局
    void dealSystemGsettingChange(const QString);
    void initGsetting();
    void initConnect();
    void btnState();//损坏图片的按钮状态
    QString btnStyle(QString iconName);//损坏图片按钮置灰的样式

private Q_SLOTS:


Q_SIGNALS:
    void showInfor();//主界面显示信息栏
    void showSidebar();//主界面显示相册
    void isDelete(bool isDel);//判断删除
    void setFontSizeSignal(int);//字体变化
    void hideTwoBar();//两栏隐藏，进入裁剪模式
    void startCutting();

};

#endif // TOOLBAR_H
